#include <iostream>
#include <vector>

using namespace std;

int main()
{

    int n, m;
    cin>>n>>m;

    vector<vector<char>> palya(n+2);

    for(int i=0;i<n+2;i++)
    {
        palya.at(i).resize(m+2);
    }


    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=m;j++)
        {
            cin>>palya.at(i).at(j);
        }
    }

    for(int i=0;i<n+2;i++)
    {
        for(int j=0;j<m+2;j++)
        {
            if(i==0 || j==0 || i==n+1 || j==m+1)
            {
                palya.at(i).at(j)='P';
            }
        }
    }



    int svalt=0;


    do
    {

    svalt=0;

    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=m;j++)
        {
            if(palya.at(i).at(j)=='.')
            {
                if(palya.at(i-1).at(j)=='X' || palya.at(i).at(j-1)=='X' ||
                   palya.at(i+1).at(j)=='X' || palya.at(i).at(j+1)=='X')
                {
                    palya.at(i).at(j)='T';
                }

            }
        }
    }



    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=m;j++)
        {
            if(palya.at(i).at(j)=='.')
            {
                if(palya.at(i-1).at(j)=='S' || palya.at(i).at(j-1)=='S' ||
                   palya.at(i+1).at(j)=='S' || palya.at(i).at(j+1)=='S')
                {
                    palya.at(i).at(j)='Q';
                    svalt++;
                }

            }
        }
    }



    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=m;j++)
        {
            if(palya.at(i).at(j)=='T')
            {
                  palya.at(i).at(j)='X';
            }
        }
    }

    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=m;j++)
        {
            if(palya.at(i).at(j)=='Q')
            {
                  palya.at(i).at(j)='S';
            }
        }
    }






    }while(svalt!=0);


    int sek=0;


    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=m;j++)
        {




            if(palya.at(i).at(j)=='S')
            {

                sek++;

            }
        }

    }

    cout<<sek;










    return 0;
}